package cn.com.infosec.asn1.util;

import cn.com.infosec.asn1.ASN1Sequence;
import cn.com.infosec.asn1.ASN1Set;
import cn.com.infosec.asn1.DERConstructedSequence;
import cn.com.infosec.asn1.DEREncodable;
import cn.com.infosec.asn1.DERObjectIdentifier;

public class SubjectDNUtil {
   private static final DERObjectIdentifier CN = new DERObjectIdentifier("2.5.4.3");
   private static final String SORTDN_CN_FIRST = "cnfirst";
   private static final String SORTDN_CN_LAST = "cnlast";

   public static DEREncodable sortDN(ASN1Sequence dn, String pName) {
      if ((pName = System.getProperty(pName)) != null && !pName.equals("")) {
         if (((DERObjectIdentifier)((ASN1Sequence)((ASN1Set)dn.getObjectAt(0)).getObjectAt(0)).getObjectAt(0)).equals(CN)) {
            if (pName.toLowerCase().equals("cnfirst")) {
               return dn;
            }

            if (pName.toLowerCase().equals("cnlast")) {
               return turnDN(dn);
            }
         } else {
            if (pName.toLowerCase().equals("cnfirst")) {
               return turnDN(dn);
            }

            if (pName.toLowerCase().equals("cnlast")) {
               return dn;
            }
         }

         return dn;
      } else {
         return dn;
      }
   }

   private static DEREncodable turnDN(ASN1Sequence dn) {
      DERConstructedSequence var1;
      var1 = new DERConstructedSequence.<init>();
      int var2 = 0;

      for(int var3 = dn.size(); var2 < var3; ++var2) {
         var1.addObject(dn.getObjectAt(var3 - var2 - 1));
      }

      return var1;
   }
}
